﻿using System;
using System.Diagnostics;
using System.Linq;
using Caliburn.Micro;
using Microsoft.Phone.Shell;

namespace WP7_LiveTileDemo.ViewModels
{
    public class MainPageViewModel : PropertyChangedBase
    {
        public void CreateSecondaryTile()
        {
            var foundTile = ShellTile.ActiveTiles.FirstOrDefault(
                x => x.NavigationUri.ToString().Contains("DetailId=123"));

            if ( foundTile == null )
            {
                var secondaryTile = new StandardTileData
                                        {
                                            BackgroundImage = new Uri("Images/SecondaryTileFrontIcon.jpg", UriKind.Relative),
                                            Title = "Secondary Tile",
                                            Count = null,
                                            BackTitle = "Back of Tile",
                                            BackContent = "You can put some data here......",
                                            //BackBackgroundImage = new Uri("Images/SecondaryTileFrontIcon.jpg", UriKind.Relative)
                                        };

                ShellTile.Create(new Uri("/Views/DetailsPage.xaml?DetailId=123", UriKind.Relative), secondaryTile);                
            }
        }

        public void CreateApplicationTile()
        {
            var shellTile = ShellTile.ActiveTiles.First();

            if( shellTile != null )
            {
                var standardTileData = new StandardTileData
                                           {
                                               Title = "Live Tile Demo",
                                               BackgroundImage =
                                                   new Uri("Images/SecondaryTileFrontIcon.jpg", UriKind.Relative),
                                               Count = null,
                                               BackTitle = "Back Tile",
                                               BackContent = "Live Tile Demo Back Title"
                                           };
                shellTile.Update(standardTileData);
            }
        }

        public void EditExistingTile()
        {
            var foundTile = ShellTile.ActiveTiles.FirstOrDefault(x => x.NavigationUri.ToString().Contains("DetailId=123"));

            if (foundTile != null)
            {
                // what sucks here is we cannot get access to the information on the existing tile...
                var liveTile = new StandardTileData
                {
                    Title = "New Tile Text",
                    Count = 123
                };

                foundTile.Update(liveTile);
            }
        }

        public void DeleteExistingTile()
        {
            var foundTile = ShellTile.ActiveTiles.FirstOrDefault(x => x.NavigationUri.ToString().Contains("DetailId=123"));

            if ( foundTile != null )
            {
                foundTile.Delete();
            }
        }
    }
}
